/* Code developed for DvCon 2010 
 By Ben Cohen, Srinivasan Venkataramanan, Ajeetha Kumari, and Lisa Piper
 "SystemVerilog Assertions Handbook, 2nd edition"ISBN  878-0-9705394-8-7
  www.systemverilog.us  ben@systemverilog.us
  www.cvcblr.com, info@cvcblr.com

 All code provided in this presentation is distributed
 with *ABSOLUTELY NO SUPPORT* and *NO WARRANTY* from the authors.  
*/

checker chk_immd(logic the_what,
                 string  msg,
                 logic clk);
 // The clocking event in the assertion is needed because 
 // the checker can be instantiated in a procedure with a
 // blocking timing, which ivalidates the inferred clock
 // The use of default clocking is also OK 
  ap_test_now: assert property(@ (posedge clk) the_what) else 
           $error("%0t %s, the_what=%b ", $time, msg, the_what );

endchecker : chk_immd  
